<template>
  <div class="calendar">
    <v-btn
      icon
      class="ml-auto"
      @click="removeCalendar"
    >
      <v-icon>mdi-close-circle-outline</v-icon>
    </v-btn>

    <v-sheet height="600" width="100%">
      <v-calendar
        ref="calendar"
        v-model="value"
        :weekdays="weekday"
        :type="type"
        :events="events"
        :event-overlap-mode="mode"
        :event-overlap-threshold="30"
        :event-color="getEventColor"
        locale="ru"
        @change="getEvents"
      ></v-calendar>
    </v-sheet>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import api from '@/API/api'

export default {
  name: 'Calendar',
  data: () => ({
    type: 'month',
    types: ['month', 'week', 'day', '4day'],
    mode: 'stack',
    modes: ['stack', 'column'],
    weekday: [1, 2, 3, 4, 5, 6, 0],
    task: [],
    weekdays: [
      { text: 'Sun - Sat', value: [0, 1, 2, 3, 4, 5, 6] },
      { text: 'Mon - Sun', value: [1, 2, 3, 4, 5, 6, 0] },
      { text: 'Mon - Fri', value: [1, 2, 3, 4, 5] },
      { text: 'Mon, Wed, Fri', value: [1, 3, 5] },
    ],
    value: '',
    events: [],
    colors: ['blue', 'indigo', 'deep-purple', 'cyan', 'green', 'orange', 'grey darken-1'],
    names: ['Meeting', 'Holiday', 'PTO', 'Travel', 'Event', 'Birthday', 'Conference', 'Party'],
  }),
  computed: {
    ...mapGetters(["USER"]),
  },
  props: {
    lead: Object,
    title: String,
    subtitle: String,
    isPopup: Boolean
  },
  emits: [
    'removeCalendar'
  ],
  methods: {
    removeCalendar () {
      this.$emit('removeCalendar')
    },
    async getEvents ({ start, end }) {
      this.task = this.lead.task
      for (let i = 0; i < this.task.length; i++) {
        this.events.push({
          name: this.task[i].task + ' ' + this.task[i].taskHour,
          start: new Date(this.task[i].taskDate),
          color: this.colors[this.rnd(0, this.colors.length - 1)],
          timed: '',
        })
      }
    },
    getEventColor (event) {
      return event.color
    },
    rnd (a, b) {
      return Math.floor((b - a + 1) * Math.random()) + a
    },
  },
}
</script>

<style scoped lang="scss">
  .calendar {
    display: flex;
    flex-direction: column;
    align-items: center;
    width: 100%;
    .month {
      display: flex;
      align-items: center;
      margin-bottom: 25px;
      p {
        margin: 0;
        width: 200px;
        text-align: center;
        font-weight: 600;
        font-size: 13px;
      }
      i {
        cursor: pointer;
      }
    }
    .wrap {
      width: 100%;
      .weekdays {
        margin: 0;
        padding: 10px 0;
        width: 100%;
        li {
          display: inline-block;
          width: 13.6%;
          color: rgba(0, 0, 0, 0.3);
          text-align: center;
          margin: 3px;
          border-radius: 4px;
          cursor: pointer;
        }
      }
      .days {
        padding: 10px 0;
        margin: 0;
        .day {
          height: 28px;
          cursor: pointer;
          margin: 3px;
          border-radius: 4px;
          list-style-type: none;
          display: inline-flex;
          align-items: center;
          justify-content: center;
          width: 13.6%;
          text-align: center;
          font-size:12px;
          color: #3183FF;
          background-color: #E5E5E5;
          transition: all .3s;
          &:hover {
            background: #FFFFFF;
          }
          &._active {
            box-shadow: inset 0px 2px 0px #84BD5A;
          }
          &._active-red {
            box-shadow: inset 0px 2px 0px #DB4661;
          }
        }
      }
      @media screen and (max-width:720px) {
        .weekdays li, .days li {width: 13.1%;}
      }
      @media screen and (max-width: 420px) {
        .weekdays li, .days li {width: 12.5%;}
        .days li .active {padding: 2px;}
      }
      @media screen and (max-width: 290px) {
        .weekdays li, .days li {width: 12.2%;}
      }
    }
    .calendar-title {
      width: 100%;
      .calendar-title-wrap {
        display: flex;
        border: 1px solid rgba(0, 0, 0, 0.16);
        box-sizing: border-box;
        border-radius: 4px;
        .left-container {
          min-width: 250px;
          padding-right: 20px;
          .wrap {
            display: flex;
            justify-content: space-between;
          }
        }
      }
    }
  }
</style>
